from sqlalchemy.orm import relationship

from .account_base import AccountBase


class Account(AccountBase):
    __mapper_args__ = {"polymorphic_identity": ""}

    products = relationship("Product", primaryjoin="Account.id==Product.account_id", back_populates="account")

    def can_delete(self, advanced_delete):
        if len(self.products) > 0:
            return False, "Account has products"
        return super(Account, self).can_delete(advanced_delete)
