import uuid

from datetime import datetime

from sqlalchemy import Column, DateTime, Unicode
from sqlalchemy.dialects.postgresql import BYTEA, UUID

from .meta import Base


class DbImage(Base):
    __tablename__ = "images"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    resource_id = Column("resource_id", UUID(as_uuid=True), nullable=False)
    resource_type = Column("resource_type", Unicode(255), nullable=False)
    image = Column("image", BYTEA, nullable=False)
    thumbnail = Column("thumbnail", BYTEA, nullable=False)
    creation_date = Column("creation_date", DateTime(), nullable=False)

    def __init__(
        self,
        resource_id=None,
        resource_type=None,
        image=None,
        thumbnail=None,
        creation_date=None,
        id_=None,
    ):
        self.resource_id = resource_id
        self.resource_type = resource_type
        self.image = image
        self.thumbnail = thumbnail
        self.creation_date = creation_date or datetime.utcnow()
        self.id = id_
