import uuid

from sqlalchemy import Column, Date, Enum, PickleType, Unicode
from sqlalchemy.dialects.postgresql import UUID

from .meta import Base
from .setting_type import SettingType


class DbSetting(Base):
    __tablename__ = "settings"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    name = Column("name", Unicode(255), unique=True, nullable=False)
    data = Column("data", PickleType)
    setting_type = Column("setting_type", Enum(SettingType), nullable=False)

    valid_from = Column("valid_from", Date(), nullable=True)
    valid_till = Column("valid_till", Date(), nullable=True)

    def __init__(self, id_=None, setting_type=None, name=None, data=None, valid_from=None, valid_till=None):
        self.id = id_
        self.setting_type = setting_type
        self.name = name
        self.data = data
        self.valid_from = valid_from
        self.valid_till = valid_till
