import uuid

from sqlalchemy import Column, DateTime, ForeignKey
from sqlalchemy.dialects.postgresql import UUID

from .meta import Base


class Fingerprint(Base):
    __tablename__ = "fingerprints"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    employee_id = Column("employee_id", UUID(as_uuid=True), ForeignKey("employees.id"))
    date = Column("date", DateTime)

    def __init__(self, id_=None, employee_id=None, date=None):
        self.id = id_
        self.employee_id = employee_id
        self.date = date
        self.fingerprint_type = 0
