from __future__ import annotations

import uuid

from typing import List

from sqlalchemy import Column, Unicode
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship

from .meta import Base
from .role import Role
from .role_permission import role_permission


class Permission(Base):
    __tablename__ = "permissions"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    name = Column("name", Unicode(255), unique=True)

    roles: List[Role] = relationship("Role", secondary=role_permission, back_populates="permissions")

    def __init__(self, name=None, id_=None):
        self.name = name
        self.id = id_
