import uuid

from sqlalchemy import Boolean, Column, Unicode
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship

from .meta import Base


class ProductGroup(Base):
    __tablename__ = "product_groups"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    name = Column("name", Unicode(255), unique=True)
    is_fixture = Column("is_fixture", Boolean, nullable=False)

    products = relationship("Product", back_populates="product_group")

    def __init__(self, name=None, id_=None, is_fixture=False):
        self.name = name
        self.id = id_
        self.is_fixture = is_fixture

    @classmethod
    def menu_item(cls):
        return uuid.UUID("dad46805-f577-4e5b-8073-9b788e0173fc")

    @classmethod
    def semi(cls):
        return uuid.UUID("e6bf81b9-1e9b-499f-81d5-ab5662e9d9b1")
