import uuid

from sqlalchemy import Column, ForeignKey, Integer, UniqueConstraint
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship

from .meta import Base


class RecipeItem(Base):
    __tablename__ = "recipe_items"
    __table_args__ = (UniqueConstraint("recipe_id", "product_id"),)

    id = Column("recipe_item_id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    recipe_id = Column("recipe_id", UUID(as_uuid=True), ForeignKey("recipes.id"), nullable=False)
    product_id = Column("product_id", UUID(as_uuid=True), ForeignKey("products.id"), nullable=False)
    quantity = Column("quantity", Integer, nullable=False)
    price = Column("price", Integer, nullable=False)

    product = relationship("Product")

    def __init__(self, recipe_id=None, product_id=None, quantity=None, price=None, id_=None):
        self.recipe_id = recipe_id
        self.product_id = product_id
        self.quantity = quantity
        self.price = price
        self.id = id_
