from __future__ import annotations

import uuid

from sqlalchemy import Column, Unicode
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship

from .meta import Base
from .role_permission import role_permission


class Role(Base):
    __tablename__ = "roles"

    id = Column("id", UUID(as_uuid=True), primary_key=True, default=uuid.uuid4)
    name = Column("name", Unicode(255), unique=True)

    permissions = relationship("Permission", secondary=role_permission, back_populates="roles")

    def __init__(self, name=None, id_=None):
        self.name = name
        self.id = id_
